/// <reference path="babylon.2.1.d.ts" />

var BjsApp = BjsApp || {};

BjsApp.init = function(){
	//get the canvas
	var canvas = document.getElementById('renderCanvas');
	
	//create a BabylonJS engine object
	var engine = new BABYLON.Engine(canvas, true);
	
	//create scene
	var scene = new BABYLON.Scene(engine);
    
    //create camera
    var camera = new BABYLON.FreeCamera('FreeCamera', new BABYLON.Vector3(0, 2, -15), scene);
    camera.attachControl(canvas);
    
    
    //light environment
    var light = new BABYLON.HemisphericLight('light1', new BABYLON.Vector3(0, 1, 0), scene);
    
    //ground plane
    var ground = BABYLON.Mesh.CreateGround('ground1', 20, 20, 4, scene);
    
	//Make grass material
	var grassMaterial = new BABYLON.StandardMaterial('grass', scene);
	
	// Assign grass a texture
	grassMaterial.diffuseTexture = new BABYLON.Texture('images/grass.png', scene);
	
	//Modify UVs
	grassMaterial.diffuseTexture.uScale = 10;
	grassMaterial.diffuseTexture.vScale = 4;
	
	//Apply texture to ground
	ground.material = grassMaterial;
	
    //create a sphere object
    var sphere = BABYLON.Mesh.CreateSphere('sphere1', 16, 2, scene);
    sphere.position.y = 1;
    
    //create a 2nd sphere object
    var sphere2 = BABYLON.Mesh.CreateSphere('sphere2', 16, 2, scene);
    sphere2.position = new BABYLON.Vector3(3, 3, 3);
	
	//create a new material
	var sphereMaterial = new BABYLON.StandardMaterial('sphereMat', scene);
	
	//apply color to material
	sphereMaterial.diffuseColor = new BABYLON.Color3(1, 0, 0);
	
	//adjust opacity
	sphereMaterial.alpha = 0.5;
	
	sphere2.material = sphereMaterial;
    
    //rotaion with vector
    sphere2.rotation = new BABYLON.Vector3(45, 45, -45);
    
    //scaling with vector
    sphere2.scaling = new BABYLON.Vector3(2, .5, .5);
    
    //make a box
    var box = BABYLON.Mesh.CreateBox('box',1, scene);
    box.position = new BABYLON.Vector3(7, 2, -5);

    //rotating a specific axis
    box.rotation.y = 12;
    
    //scaling a specific axis
    box.scaling.y = 12;
	
	//Create Material
	var redMaterial = new BABYLON.StandardMaterial('redMat', scene);
	
	//Color Material
	redMaterial.diffuseColor = new BABYLON.Color3(1, 0, 0);
	
	//Apply Material!
	sphere2.material = redMaterial;
	
	//Modify opacity
	redMaterial.alpha = 0.5;
	
    //Apply material to cylinder
    box.material = redMaterial;
	
    //make a Cylinder
    var cylinder = BABYLON.Mesh.CreateCylinder('cyl', 5, 1, .5, 16, scene);
	
	//Apply material to cylinder
    cylinder.material = redMaterial;
	
    //Make Lines
    var lines = BABYLON.Mesh.CreateLines('lines', [3, 
    new BABYLON.Vector3(0, 5, 0),
    new BABYLON.Vector3(1, 5, 0),
    new BABYLON.Vector3(0, 5, 1),
    new BABYLON.Vector3(2, 2, 0),
    new BABYLON.Vector3(1, 5, -5),
    ], scene);
	

                                                   
    //render scene
    engine.runRenderLoop(function(){
        scene.render();
    });

    //listen for resizing event
   window.addEventListener('resize', function(){
        engine.resize();
                                                   });
                                                   
};